KPL/MK

Meta-kernel for ExoMars RSP Dataset v -- Telemetry 0002_001
==========================================================================

   This meta-kernel lists the ExoMarsRSP Telemetry SPICE kernels
   that provide information for the Telemetry scenario.

   The kernels listed in this meta-kernel and the order in which
   they are listed are picked to provide the best data available and
   the most complete coverage for the ExoMarsRSP Telemetry scenario.

   This meta-kernel was generated with the Auxiliary Data Conversion
   System version: ADCSng v1.3.0.


Usage of the Meta-kernel
-------------------------------------------------------------------------

   This file is used by the SPICE system as follows: programs that make use
   of this kernel must "load" the kernel normally during program
   initialization. Loading the kernel associates the data items with
   their names in a data structure called the "kernel pool". The SPICELIB
   routine FURNSH loads a kernel into the pool.

   The kernels listed below can be obtained from the ESA SPICE FTP server:

      ftp://spiftp.esac.esa.int/data/SPICE/ExoMarsRSP/kernels/


Implementation Notes
-------------------------------------------------------------------------

   It is recommended that users make a local copy of this file and
   modify the value of the PATH_VALUES keyword to point to the actual
   location of the ExoMarsRSP SPICE data set's ``data'' directory on
   their system. Replacing ``/'' with ``\'' and converting line
   terminators to the format native to the user's system may also be
   required if this meta-kernel is to be used on a non-UNIX workstation.


-------------------

   This file was created on June 3, 2020 by Marc Costa Sitja ESA/ESAC.
   The original name of this file was emrsp_tlm_0002_001.tm.


   \begindata

     PATH_VALUES       = ( '..' )

     PATH_SYMBOLS      = ( 'KERNELS' )

     KERNELS_TO_LOAD   = (

                           '$KERNELS/ck/emrsp_rm_surf_rec_0001_v001.bc'
                           '$KERNELS/ck/emrsp_rm_surf_rec_0002_v001.bc'
                           '$KERNELS/ck/emrsp_rm_surf_interp-tlm_0001_v001.bc'

                           '$KERNELS/fk/emrsp_rm_v006.tf'

                           '$KERNELS/lsk/naif0012.tls'

                           '$KERNELS/sclk/emrsp_rm_test_ret_20191128_v001.tsc'

                           '$KERNELS/spk/emrsp_rm_gnc-tlm_0001_v001.bsp'
                           '$KERNELS/spk/emrsp_rm_mech-tlm_0001_v001.bsp'
                           '$KERNELS/spk/emrsp_rm_interp-tlm_0001_v001.bsp'
                           '$KERNELS/spk/mar097_20160314_20300101.bsp'

                         )

   \begintext


SPICE Kernel Dataset Version
------------------------------------------------------------------------

   The SPICE Kernel Dataset version of the kernels present in this
   meta-kernel is provided by the following keyword (please note that
   this might not be the last version of the SPICE Kernel Dataset):

   \begindata

      SKD_VERSION = 'v_0002_001'

   \begintext


Contact Information
------------------------------------------------------------------------

   If you have any questions regarding this file contact the
   ESA SPICE Service (ESS) at ESAC:

           Marc Costa Sitja
           (+34) 91-8131-457
           esa_spice@sciops.esa.int, marc.costa@esa.int,


End of MK file.