import os

from glob import glob
from bs4 import BeautifulSoup

def transfer(bundle, start_dir=''):

    if not start_dir:
        start_dir = os.getcwd()

    labels = []
    pattern = "*.xml"

    for dir, _, _ in os.walk(start_dir):
        labels.extend(glob(os.path.join(dir, pattern)))
    labels.sort()

    lidvids = []
    paths = []
    for label in labels:
        with open(label, "r") as xml:
            soup = BeautifulSoup(xml, features="html.parser")
            lid = soup.find('logical_identifier').string
            vid = soup.find('version_id').string

            lidvids.append('{}::{}'.format(lid,vid))
            paths.append('./'+label.split(bundle+'/')[-1])

    width = len(max(lidvids, key=len)) + 1

    with open('{}.transfer'.format(bundle), "w+") as f:
        for lidvid, path in zip(lidvids, paths):
            lidvid = lidvid.ljust(width)
            f.write('{} {}\n'.format(lidvid, path))

    return


def checksum():

    return