#!/usr/bin/perl
#   metacharacters:        {}[]()^$.|*+?\
#   for character class:   -]\^$

open arc, '../src/ROS_V06.TM';
open old, '../src/ROS_OPS.TM';
open new, '>/home/bgrieger/COMETS/ROSETTA/SPICE/rosetta/kernels/mk/ROS_OPS.TM';

 HEADER: while( <arc> ) {
     if ( /^   This file was created on / ) {
	 $created = $_;
	 last HEADER;
     }
}

PREAMBLE: while ( <old> ) {
    if ( /^   This file was created on April 1, 2019 by Marc Costa Sitja ESAC\/ESA.$/ ) {
	print new $created;
    } elsif ( /^\s*KERNELS_TO_LOAD\s*=\s*\(\s*$/ ) {
	print new;
	last PREAMBLE;
    } else {
	print new;
    }
}

 L3: while( <arc> ) {
     if ( /^\s*KERNELS_TO_LOAD\s*=\s*\(\s*$/ ) {
	 last L3;
     }
}

$i = 0;
 L5: while( <old> ) {
     if ( /^\s*\\begintext\s*$/ ) {
	 last L5;
     } elsif ( /\/former_versions\/([^']+)/ ) {
	 $former[$i] = $1;
	 print "$former[$i]\n";
	 $i++;
     }
}

 L4: while( <arc> ) {
     if ( /^\s*\\begintext\s*$/ ) {
	 print new;
	 last L4;
     } else {
	 s/\/CK\//\/ck\//;
	 s/\/DSK\//\/dsk\//;
	 s/\/FK\//\/fk\//;
	 s/\/IK\//\/ik\//;
	 s/\/LSK\//\/lsk\//;
	 s/\/PCK\//\/pck\//;
	 s/\/SCLK\//\/sclk\//;
	 s/\/SPK\//\/spk\//;
	 $record = $_;
	 foreach ( @former ) {
	     if ( $record =~ /^(.+)($_.+)$/ ) {
		 $record = "$1former_versions/$2\n";
	     }
	 }
	 print new $record;
     }
}

while( <old> ) {
    print new;
}
