KPL/MK

   This meta-kernel lists the CASSINI SPICE kernels providing coverage
   for 2003. All of the kernels listed below are archived in the CAS
   SPICE data set (DATA_SET_ID = "CO-S/J/E/V-SPICE-6-V1.0"). This set
   of files and the order in which they are listed were picked to
   provide the best available data and the most complete coverage for
   the specified year based on the information about the kernels
   available at the time this meta-kernel was made. For detailed
   information about the kernels listed below refer to the internal
   comments included in the kernels and the documentation accompanying
   the CASSINI SPICE data set.

   WARNING: the list of kernels in this meta-kernel does not include
   any PCK files, preventing this data collection from being usable for
   computing derived parameters that require knowledge of the natural
   body orientations, rotations and shapes. The reason for this
   omission is that the multitude of PCK files produced by the CASSINI
   project and archived in the CASSINI SPICE data set did not allow
   NAIF to make a reasonable pick for this kernel type. It is the
   user's responsibility to identify the PCK(s) most suitable for
   his/her application and to load this(these) PCK(s) in addition to
   this meta-kernel.

   It is recommended that users make a local copy of this file and
   modify the value of the PATH_VALUES keyword to point to the actual
   location of the CAS SPICE data set's ``data'' directory on their
   system. Replacing ``/'' with ``\'' and converting line terminators
   to the format native to the user's system may also be required if
   this meta-kernel is to be used on a non-UNIX workstation.

   This file was created on March 12, 2007 by Boris Semenov,
   NAIF/JPL. The original name of this file was cas_2003_v01.tm.

   \begindata

      PATH_VALUES     = ( './data' )

      PATH_SYMBOLS    = ( 'KERNELS' )

      KERNELS_TO_LOAD = (

                          '$KERNELS/lsk/naif0008.tls'

                          '$KERNELS/fk/cas_rocks_v09.tf'

                          '$KERNELS/fk/cas_v39.tf'

                          '$KERNELS/ik/cas_caps_v03.ti'
                          '$KERNELS/ik/cas_cda_v01.ti'
                          '$KERNELS/ik/cas_cirs_v09.ti'
                          '$KERNELS/ik/cas_inms_v02.ti'
                          '$KERNELS/ik/cas_iss_v10.ti'
                          '$KERNELS/ik/cas_mag_v01.ti'
                          '$KERNELS/ik/cas_mimi_v11.ti'
                          '$KERNELS/ik/cas_radar_v11.ti'
                          '$KERNELS/ik/cas_rpws_v01.ti'
                          '$KERNELS/ik/cas_rss_v03.ti'
                          '$KERNELS/ik/cas_sru_v02.ti'
                          '$KERNELS/ik/cas_uvis_v05.ti'
                          '$KERNELS/ik/cas_vims_v06.ti'

                          '$KERNELS/sclk/cas00105.tsc'

                          '$KERNELS/spk/051212AP_RE_90165_14363.bsp'
                          '$KERNELS/spk/060222AP_IRRE_00256_14363.bsp'

                          '$KERNELS/spk/041014R_SCPSE_01066_04199.bsp'

                          '$KERNELS/ck/03113_03115pa.bc'
                          '$KERNELS/ck/03119_03166_port2_pa.bc'
                          '$KERNELS/ck/03166_03222pd.bc'
                          '$KERNELS/ck/03222_03292pc.bc'
                          '$KERNELS/ck/03292_04009pd.bc'

                          '$KERNELS/ck/02224_03005ra.bc'
                          '$KERNELS/ck/03005_03115ra.bc'
                          '$KERNELS/ck/03115_03236ra.bc'
                          '$KERNELS/ck/03236_04002ra.bc'

                          '$KERNELS/ck/cas_cda_20070309.bc'

                        )

   \begintext
