KPL/MK

   This meta-kernel was used to produce image products included in the
   MER-1 data delivery to PDS covering SOLs 811-900. This setup does
   not include kernels that provide cruise stage position and
   orientation or rover surface position and orientation. It only
   includes kernels that are needed to compute global geometry at the
   landing site.

   All of the kernels listed below are archived in the MER1 SPICE data
   set (DATA_SET_ID = "MER1-M-SPICE-6-V1.0"). For detailed information
   about the kernels listed below refer to the internal comments
   included in the kernels and the documentation accompanying the MER1
   SPICE data set.
 
   It is recommended that users make a local copy of this file and
   modify the value of the PATH_VALUES keyword to point to the actual
   location of the MER1 SPICE data set's ``data'' directory on their
   system. Replacing ``/'' with ``\'' and converting line terminators
   to the format native to the user's system may also be required if
   this meta-kernel is to be used on a non-UNIX workstation.
 
   This file was created on March 1, 2007 by Boris Semenov, NAIF/JPL.
   The original name of this file was mer1_rel10_v01.tm.

   \begindata

      PATH_VALUES       = (
                          './data'
                          )
      PATH_SYMBOLS      = (
                          'KERNELS'
                          )
      KERNELS_TO_LOAD   = (
                          '$KERNELS/lsk/naif0008.tls'
                          '$KERNELS/sclk/mer_253_sclkscet_00019.tsc'
                          '$KERNELS/sclk/mer1_hlst_tm20b3_v2.tsc'
                          '$KERNELS/pck/mars_iau2000_v0.tpc'
                          '$KERNELS/spk/de410.bsp'
                          '$KERNELS/spk/mer1_ls_040128_iau2000_v1.bsp'
                          '$KERNELS/spk/mer1_still_at_ls_v1.bsp'
                          '$KERNELS/fk/mer1_v09.tf'
                          )

      SPACECRAFT_ID     = -253
      CENTER_ID         = 499
      LANDING_TIME      = '2004-01-25 04:55'
      LANDING_SOL_INDEX = 1
      BODY10_GM         =   132712440035.0199

   \begintext

