KPL/MK

   This meta-kernel lists the MRO SPICE kernels providing coverage for
   2006. All of the kernels listed below are archived in the MRO SPICE
   data set (DATA_SET_ID = "MRO-M-SPICE-6-V1.0"). This set of files and
   the order in which they are listed were picked to provide the best
   available data and the most complete coverage for the specified year
   based on the information about the kernels available at the time
   this meta-kernel was made. For detailed information about the
   kernels listed below refer to the internal comments included in the
   kernels and the documentation accompanying the MRO SPICE data set.

   It is recommended that users make a local copy of this file and
   modify the value of the PATH_VALUES keyword to point to the actual
   location of the MRO SPICE data set's ``data'' directory on their
   system. Replacing ``/'' with ``\'' and converting line terminators
   to the format native to the user's system may also be required if
   this meta-kernel is to be used on a non-UNIX workstation.

   This file was created on June 8, 2007 by Boris Semenov, NAIF/JPL.
   The original name of this file was mro_2006_v01.tm.

   \begindata

      PATH_VALUES     = ( './data' )

      PATH_SYMBOLS    = ( 'KERNELS' )

      KERNELS_TO_LOAD = (

                          '$KERNELS/lsk/naif0008.tls'

                          '$KERNELS/pck/pck00008.tpc'

                          '$KERNELS/sclk/mro_sclkscet_00021_65536.tsc'

                          '$KERNELS/fk/mro_v10.tf'

                          '$KERNELS/ik/mro_crism_v10.ti'
                          '$KERNELS/ik/mro_ctx_v10.ti'
                          '$KERNELS/ik/mro_hirise_v10.ti'
                          '$KERNELS/ik/mro_mcs_v10.ti'
                          '$KERNELS/ik/mro_onc_v10.ti'

                          '$KERNELS/spk/mar063.bsp'
                          '$KERNELS/spk/de410.bsp'

                          '$KERNELS/spk/mro_cruise.bsp'
                          '$KERNELS/spk/mro_ab.bsp'
                          '$KERNELS/spk/mro_psp1.bsp'

                          '$KERNELS/spk/mro_struct_v10.bsp'

                          '$KERNELS/ck/mro_hga_psp_060911_060915p.bc'
                          '$KERNELS/ck/mro_hga_psp_060915_060924p.bc'
                          '$KERNELS/ck/mro_hga_psp_060924_061013p.bc'
                          '$KERNELS/ck/mro_hga_psp_061012_061107p.bc'
                          '$KERNELS/ck/mro_hga_psp_061107_061111p.bc'
                          '$KERNELS/ck/mro_hga_psp_061111_061118p.bc'
                          '$KERNELS/ck/mro_hga_psp_061118_061125p.bc'
                          '$KERNELS/ck/mro_hga_psp_061125_061203p.bc'
                          '$KERNELS/ck/mro_hga_psp_061202_061209p.bc'
                          '$KERNELS/ck/mro_hga_psp_061209_061215p.bc'
                          '$KERNELS/ck/mro_hga_psp_061215_061227p.bc'
                          '$KERNELS/ck/mro_hga_psp_061227_061231p.bc'
                          '$KERNELS/ck/mro_hga_psp_061231_070108p.bc'

                          '$KERNELS/ck/mro_sa_psp_060911_060915p.bc'
                          '$KERNELS/ck/mro_sa_psp_060915_060924p.bc'
                          '$KERNELS/ck/mro_sa_psp_060924_061013p.bc'
                          '$KERNELS/ck/mro_sa_psp_061012_061107p.bc'
                          '$KERNELS/ck/mro_sa_psp_061107_061111p.bc'
                          '$KERNELS/ck/mro_sa_psp_061111_061118p.bc'
                          '$KERNELS/ck/mro_sa_psp_061118_061125p.bc'
                          '$KERNELS/ck/mro_sa_psp_061125_061203p.bc'
                          '$KERNELS/ck/mro_sa_psp_061202_061209p.bc'
                          '$KERNELS/ck/mro_sa_psp_061209_061215p.bc'
                          '$KERNELS/ck/mro_sa_psp_061215_061227p.bc'
                          '$KERNELS/ck/mro_sa_psp_061227_061231p.bc'
                          '$KERNELS/ck/mro_sa_psp_061231_070108p.bc'

                          '$KERNELS/ck/mro_sc_psp_060911_060915p.bc'
                          '$KERNELS/ck/mro_sc_psp_060915_060924p.bc'
                          '$KERNELS/ck/mro_sc_psp_060924_061013p.bc'
                          '$KERNELS/ck/mro_sc_psp_061012_061107p.bc'
                          '$KERNELS/ck/mro_sc_psp_061107_061111p.bc'
                          '$KERNELS/ck/mro_sc_psp_061111_061118p.bc'
                          '$KERNELS/ck/mro_sc_psp_061118_061125p.bc'
                          '$KERNELS/ck/mro_sc_psp_061125_061202p.bc'
                          '$KERNELS/ck/mro_sc_psp_061202_061209p.bc'
                          '$KERNELS/ck/mro_sc_psp_061209_061215p.bc'
                          '$KERNELS/ck/mro_sc_psp_061215_061227p.bc'
                          '$KERNELS/ck/mro_sc_psp_061227_061231p.bc'
                          '$KERNELS/ck/mro_sc_psp_061231_070108p.bc'

                          '$KERNELS/ck/mro_crm_cru_060119_060119.bc'

                          '$KERNELS/ck/mro_hga_cru_060101_060131.bc'
                          '$KERNELS/ck/mro_hga_cru_060201_060228.bc'
                          '$KERNELS/ck/mro_hga_cru_060301_060310.bc'

                          '$KERNELS/ck/mro_sa_cru_060101_060131.bc'
                          '$KERNELS/ck/mro_sa_cru_060201_060228.bc'
                          '$KERNELS/ck/mro_sa_cru_060301_060310.bc'

                          '$KERNELS/ck/mro_sc_cru_060101_060131.bc'
                          '$KERNELS/ck/mro_sc_cru_060201_060228.bc'
                          '$KERNELS/ck/mro_sc_cru_060301_060310.bc'

                          '$KERNELS/ck/mro_hga_ab_060311_060331.bc'
                          '$KERNELS/ck/mro_hga_ab_060401_060430.bc'
                          '$KERNELS/ck/mro_hga_ab_060501_060531.bc'
                          '$KERNELS/ck/mro_hga_ab_060601_060630.bc'
                          '$KERNELS/ck/mro_hga_ab_060701_060731.bc'
                          '$KERNELS/ck/mro_hga_ab_060801_060831.bc'
                          '$KERNELS/ck/mro_hga_ab_060901_060911.bc'

                          '$KERNELS/ck/mro_sa_ab_060311_060331.bc'
                          '$KERNELS/ck/mro_sa_ab_060401_060430.bc'
                          '$KERNELS/ck/mro_sa_ab_060501_060531.bc'
                          '$KERNELS/ck/mro_sa_ab_060601_060630.bc'
                          '$KERNELS/ck/mro_sa_ab_060701_060731.bc'
                          '$KERNELS/ck/mro_sa_ab_060801_060831.bc'
                          '$KERNELS/ck/mro_sa_ab_060901_060911.bc'

                          '$KERNELS/ck/mro_sc_ab_060311_060331.bc'
                          '$KERNELS/ck/mro_sc_ab_060401_060430.bc'
                          '$KERNELS/ck/mro_sc_ab_060501_060531.bc'
                          '$KERNELS/ck/mro_sc_ab_060601_060630.bc'
                          '$KERNELS/ck/mro_sc_ab_060701_060731.bc'
                          '$KERNELS/ck/mro_sc_ab_060801_060831.bc'
                          '$KERNELS/ck/mro_sc_ab_060901_060911.bc'

                          '$KERNELS/ck/mro_crm_psp_060925_060930.bc'
                          '$KERNELS/ck/mro_crm_psp_061001_061005.bc'
                          '$KERNELS/ck/mro_crm_psp_061108_061130.bc'
                          '$KERNELS/ck/mro_crm_psp_061201_061231.bc'

                          '$KERNELS/ck/mro_hga_psp_060912_060918.bc'
                          '$KERNELS/ck/mro_hga_psp_060919_060925.bc'
                          '$KERNELS/ck/mro_hga_psp_060926_061002.bc'
                          '$KERNELS/ck/mro_hga_psp_061003_061009.bc'
                          '$KERNELS/ck/mro_hga_psp_061010_061016.bc'
                          '$KERNELS/ck/mro_hga_psp_061017_061023.bc'
                          '$KERNELS/ck/mro_hga_psp_061024_061030.bc'
                          '$KERNELS/ck/mro_hga_psp_061031_061106.bc'
                          '$KERNELS/ck/mro_hga_psp_061107_061113.bc'
                          '$KERNELS/ck/mro_hga_psp_061114_061120.bc'
                          '$KERNELS/ck/mro_hga_psp_061121_061127.bc'
                          '$KERNELS/ck/mro_hga_psp_061128_061204.bc'
                          '$KERNELS/ck/mro_hga_psp_061205_061211.bc'
                          '$KERNELS/ck/mro_hga_psp_061212_061218.bc'
                          '$KERNELS/ck/mro_hga_psp_061219_061225.bc'
                          '$KERNELS/ck/mro_hga_psp_061226_070101.bc'

                          '$KERNELS/ck/mro_mcs_psp_060924_060930.bc'
                          '$KERNELS/ck/mro_mcs_psp_061001_061031.bc'

                          '$KERNELS/ck/mro_sa_psp_060912_060918.bc'
                          '$KERNELS/ck/mro_sa_psp_060919_060925.bc'
                          '$KERNELS/ck/mro_sa_psp_060926_061002.bc'
                          '$KERNELS/ck/mro_sa_psp_061003_061009.bc'
                          '$KERNELS/ck/mro_sa_psp_061010_061016.bc'
                          '$KERNELS/ck/mro_sa_psp_061017_061023.bc'
                          '$KERNELS/ck/mro_sa_psp_061024_061030.bc'
                          '$KERNELS/ck/mro_sa_psp_061031_061106.bc'
                          '$KERNELS/ck/mro_sa_psp_061107_061113.bc'
                          '$KERNELS/ck/mro_sa_psp_061114_061120.bc'
                          '$KERNELS/ck/mro_sa_psp_061121_061127.bc'
                          '$KERNELS/ck/mro_sa_psp_061128_061204.bc'
                          '$KERNELS/ck/mro_sa_psp_061205_061211.bc'
                          '$KERNELS/ck/mro_sa_psp_061212_061218.bc'
                          '$KERNELS/ck/mro_sa_psp_061219_061225.bc'
                          '$KERNELS/ck/mro_sa_psp_061226_070101.bc'

                          '$KERNELS/ck/mro_sc_psp_060912_060918.bc'
                          '$KERNELS/ck/mro_sc_psp_060919_060925.bc'
                          '$KERNELS/ck/mro_sc_psp_060926_061002.bc'
                          '$KERNELS/ck/mro_sc_psp_061003_061009.bc'
                          '$KERNELS/ck/mro_sc_psp_061010_061016.bc'
                          '$KERNELS/ck/mro_sc_psp_061017_061023.bc'
                          '$KERNELS/ck/mro_sc_psp_061024_061030.bc'
                          '$KERNELS/ck/mro_sc_psp_061031_061106.bc'
                          '$KERNELS/ck/mro_sc_psp_061107_061113.bc'
                          '$KERNELS/ck/mro_sc_psp_061114_061120.bc'
                          '$KERNELS/ck/mro_sc_psp_061121_061127.bc'
                          '$KERNELS/ck/mro_sc_psp_061128_061204.bc'
                          '$KERNELS/ck/mro_sc_psp_061205_061211.bc'
                          '$KERNELS/ck/mro_sc_psp_061212_061218.bc'
                          '$KERNELS/ck/mro_sc_psp_061219_061225.bc'
                          '$KERNELS/ck/mro_sc_psp_061226_070101.bc'

                        )

   \begintext
